package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.item.food.MushroomStewItem;
import net.minecraft.level.Level;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(MushroomStewItem.class)
public class MushroomStewItemMixin {
	@Inject(method = "use", at = @At("HEAD"), cancellable = true)
	public void use(ItemInstance stack, Level level, Player player, CallbackInfoReturnable<ItemInstance> cir) {
		if (ModConfig.DISABLE_EATING_WHEN_MAX_HP.get() && player.health >= 20) {
			cir.setReturnValue(stack);
		}
	}
}
