package xyz.pixelatedw.finalbeta.mixin;

import java.util.List;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.item.ItemInstance;
import net.minecraft.item.StoneSlabItem;
import net.minecraft.recipe.Recipe;
import net.minecraft.recipe.RecipeRegistry;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(RecipeRegistry.class)
public class RecipeRegistryMixin {

	@Shadow
	private List<Recipe> recipes;
	
	@Inject(method = "<init>", at = @At("TAIL"))
	private void recipesChanges(CallbackInfo ci) {
		if(ModConfig.FIX_SLABS_RECIPE.get()) {
			for (Recipe recipe : this.recipes) {
				ItemInstance itemStack = recipe.getOutput();
				if (itemStack.getType() instanceof StoneSlabItem) {
					itemStack.count = 6;
				}
			}			
		}
	}
	
}
